image: node:14.15.0-alpine3.10

cache:
  untracked: true
  key: '$CI_BUILD_REF_NAME'
  paths:
    - node_modules/

stages:
  - setup
  - test
  - publish

setup:
  stage: setup
  except:
    - master
  script:
    - npm ci &> /dev/null

test:
  stage: test
  except:
    - master
  script:
    - npm run build:check

publish:
  stage: publish
  only:
    - tags
  script:
    - npm run build
    - cp ./package.json ./dist/package.json
    - echo '//registry.npmjs.org/:_authToken=${NPM_TOKEN}' > ./dist/.npmrc
    - cd dist && npm publish --unsafe-perm
